// below are the configuration parameter
var imgrows=3;
var imgcols=3;
var thumbdir="thumbs/";
var imagedir="images/";
var thumbsize="height=\"150\"";
var imagesize="height=\"600\"";

// here starts the real coding
var imgspage=imgrows*imgcols;
var numpages=Math.ceil(images.length/imgspage);

function showpage(page, showall)
{
  if(page>numpages)
    page=numpages;

  if(page<1)
    page=1;

  renderpage(true, page, showall, 0);
}

function showimage(imgno)
{
  if(imgno>=images.length)
    imgno=images.length-1;

  if(imgno<0)
    imgno=0;

  renderpage(false, Math.floor(imgno/imgspage)+1, false, imgno);
}

function renderpage(isPage, page, showall, imgno)
{
  // now let's create the navigation - if needed
  var navHTML="";

  if(numpages>1)
  {
    navHTML+="<table class=\"gallery\" width=\"100%\"><tr>";

    if(!showall)
    {
      if(page<=1)
        navHTML+="<td class=\"navpage_disabled\">Previous</td>";
      else
        navHTML+="<td class=\"navpage\">"+createNavLink("Previous", page-1,false)+"</td>";
    }

    for(i=1; i<=numpages; i++)
    {
      if(i==page && !showall)
      {
        if(isPage)
          navHTML+="<td class=\"jumppage_active\">"+page+"</td>";
        else
          navHTML+="<td class=\"jumppage_active\">"+createNavLink(i, i, false)+"</td>";
      }
      else
        navHTML+="<td class=\"jumppage\">"+createNavLink(i, i, false)+"</td>";
    }

    if(!showall)
    {
      navHTML+="<td class=\"showall\">"+createNavLink("Show All", 1, true)+"</td>";

      if(page>=numpages)
        navHTML+="<td class=\"navpage_disabled\">Next</td>";
      else
        navHTML+="<td class=\"navpage\">"+createNavLink("Next", page+1,false)+"</td>";
    }

    navHTML+="</tr></table>";
  }

  // now let's create the image section
  var mainHTML="<table class=\"gallery\" width=\"100%\">";

  if(isPage)
  {
    var numrows=imgrows;

    imgno=(page-1)*imgspage;

    if(showall)
    {
      imgno=0;
      numrows=Math.ceil(images.length/imgcols);
    }

    for(row=0; row<numrows; row++)
    {
      mainHTML+="<tr>";

      for(col=0; col<imgcols; col++)
      {
        if(imgno<images.length)
          mainHTML+="<td class=\"thumbcell\">"+createImageLink(imgno)+"</td>";
        else
          mainHTML+="<td class=\"thumbcell\"></td>";

        imgno++;
      }

      mainHTML+="</tr>";
    }
  }
  else
  {
    mainHTML+="<tr>";

    if(imgno<=0)
      mainHTML+="<td class=\"navpage_disabled\">Previous</td>";
    else
      mainHTML+="<td class=\"navpage\">"+createImageNavLink("Previous", imgno-1)+"</td>";

    mainHTML+="<td class=\"jumppage_active\">"+images[imgno]+"</td>";

    if(imgno+1>=images.length)
      mainHTML+="<td class=\"navpage_disabled\">Next</td>";
    else
      mainHTML+="<td class=\"navpage\">"+createImageNavLink("Next", imgno+1)+"</td>";

    mainHTML+="</tr>";

    mainHTML+="<tr><td class=\"picturecell\" colspan=\"3\"><a href=\""+imagedir+images[imgno]+"\" target=\"_original\" class=\"picturefooter\"><img class=\"picture\" src=\""+imagedir+images[imgno]+"\" "+imagesize+"><br/>Original size...</a></td></tr>";
  }

  mainHTML+="</table>";
  
  // now let's write the page
  document.getElementById("title").innerHTML=title;
  document.getElementById("nav").innerHTML=navHTML;
  document.getElementById("main").innerHTML=mainHTML;
}

function createNavLink(title, page, showall)
{
  return "<a href=\"javascript:parent.showpage("+page+","+showall+");\">"+title+"</a>";
}

function createImageNavLink(title, imgno)
{
  return "<a href=\"javascript:parent.showimage("+imgno+");\">"+title+"</a>";
}

function createImageLink(imgno)
{
  var img=images[imgno];

  return "<a href=\"javascript:parent.showimage("+imgno+");\"><img class=\"thumb\" src=\""+thumbdir+img+"\" "+thumbsize+"></a><br/><a href=\"javascript:parent.showimage("+imgno+");\" class=\"thumbfooter\">"+img+"</a></td>";
} 

